//+------------------------------------------------------------------+
//|                PercentR - PCR.mq4                                |
//|                Copyright  2006  Scorpion@fxfisherman.com        |
//+------------------------------------------------------------------+
#property copyright "FxFisherman.com"
#property link      "http://www.fxfisherman.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 LimeGreen
#property indicator_width1 2
#property indicator_width2 2
#property indicator_level1 80
#property indicator_level2 20

extern int  HL_Period       = 55;
extern int  Shift_Bars      = 0;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = true;
extern bool alertsEmail     = false;

//---- buffers
double v1[];
double v2[];
double trend[];
  
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0, v1);
   SetIndexBuffer(1, v2);
   SetIndexBuffer(2, trend);
   return(0);
}
int start()
{
  int counted_bars = IndicatorCounted();
  if (counted_bars > 0) counted_bars--;
      int limit = MathMin(Bars - counted_bars,Bars-1);
  
   for (int i=limit; i>=0; i--)
   {
      double h = High[Highest(Symbol(), Period(), MODE_HIGH, HL_Period, i + 1)];
      double l = Low[Lowest(Symbol(), Period(), MODE_LOW, HL_Period, i + 1)];
      double p = Close[i];
      trend[i] = trend[i+1];
      if (h!=l)
      {
         v1[i] = ((h-p)/(h-l))*100;
         v2[i] = ((p-l)/(h-l))*100;
      }
      else { v1[i] = 0; v2[i] = 0; }
      if (v2[i]>v1[i])  trend[i] =  1;
      if (v2[i]<v1[i])  trend[i] = -1;
   }   
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
            
      if (trend[whichBar] != trend[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar] ==  1) doAlert(time1,mess1," up");
            if (trend[whichBar] == -1) doAlert(time1,mess1," down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+"pcr trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" pcr trend ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

